Index: XIOS/dev/branch_yushan/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1037)
@@ -79,5 +79,5 @@
                                        const double& defaultValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, defaultValue);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
 }
 
Index: XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.cpp	(revision 1037)
@@ -48,40 +48,10 @@
 
 CDomainAlgorithmInterpolate::CDomainAlgorithmInterpolate(CDomain* domainDestination, CDomain* domainSource, CInterpolateDomain* interpDomain)
-: CDomainAlgorithmTransformation(domainDestination, domainSource), interpDomain_(interpDomain), writeToFile_(false), readFromFile_(false)
-{
-  CContext* context = CContext::getCurrent();
+: CDomainAlgorithmTransformation(domainDestination, domainSource), interpDomain_(interpDomain), writeToFile_(false)
+{
   interpDomain_->checkValid(domainSource);
-  fileToReadWrite_ = "xios_interpolation_weights_";
-
-  if (interpDomain_->weight_filename.isEmpty())
-  {
-    fileToReadWrite_ += context->getId() + "_" + 
-                    domainSource->getDomainOutputName() + "_" + 
-                    domainDestination->getDomainOutputName() + ".nc";    
-  }
-  else 
-    fileToReadWrite_ = interpDomain_->weight_filename;
-
-  ifstream f(fileToReadWrite_.c_str());  
-  switch (interpDomain_->mode)
-  {
-    case CInterpolateDomain::mode_attr::read:
-      readFromFile_ = true;      
-      break;
-    case CInterpolateDomain::mode_attr::compute:
-      readFromFile_ = false;
-      break;
-    case CInterpolateDomain::mode_attr::read_or_compute:      
-      if (!f.good())
-        readFromFile_ = false;
-      else
-        readFromFile_ = true;
-      break;
-    default:
-      break;
-  } 
-
-  writeToFile_ = interpDomain_->write_weight;  
-    
+  if ((CInterpolateDomain::mode_attr::write == interpDomain_->mode) &&
+      (!interpDomain_->file.isEmpty()))
+    writeToFile_ = true;
 }
 
@@ -384,5 +354,5 @@
   }
 
-  if (writeToFile_ && !readFromFile_)
+  if (writeToFile_)
      writeRemapInfo(interpMapValue);
   exchangeRemapInfo(interpMapValue);
@@ -469,5 +439,5 @@
 void CDomainAlgorithmInterpolate::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
 {
-  if (readFromFile_ && !writeToFile_)  
+  if (CInterpolateDomain::mode_attr::read == interpDomain_->mode)  
     readRemapInfo();
   else
@@ -478,12 +448,14 @@
 
 void CDomainAlgorithmInterpolate::writeRemapInfo(std::map<int,std::vector<std::pair<int,double> > >& interpMapValue)
-{  
-  writeInterpolationInfo(fileToReadWrite_, interpMapValue);
+{
+  std::string filename = interpDomain_->file.getValue();
+  writeInterpolationInfo(filename, interpMapValue);
 }
 
 void CDomainAlgorithmInterpolate::readRemapInfo()
-{  
+{
+  std::string filename = interpDomain_->file.getValue();
   std::map<int,std::vector<std::pair<int,double> > > interpMapValue;
-  readInterpolationInfo(fileToReadWrite_, interpMapValue);
+  readInterpolationInfo(filename, interpMapValue);
 
   exchangeRemapInfo(interpMapValue);
@@ -636,6 +608,9 @@
     int countBuff = 0;
     MPI_Get_count(&recvStatus, MPI_INT, &countBuff);
+    #ifdef _usingMPI
     clientSrcRank = recvStatus.MPI_SOURCE;
-
+    #elif _usingEP
+    clientSrcRank = recvStatus.ep_src;
+    #endif
     MPI_Recv((recvIndexSrcBuff + receivedSize),
              recvBuffSize,
@@ -681,5 +656,5 @@
                                                                 const StdSize size)
 {
-  return CONetCDF4::addDimension(name, size);  
+  CONetCDF4::addDimension(name, size);  
 }
 
@@ -687,10 +662,5 @@
                                                                const std::vector<StdString>& dim)
 {
-  return CONetCDF4::addVariable(name, type, dim);
-}
-
-void CDomainAlgorithmInterpolate::WriteNetCdf::endDefinition()
-{
-  CONetCDF4::definition_end();
+  CONetCDF4::addVariable(name, type, dim);
 }
 
@@ -756,17 +726,10 @@
   MPI_Scan(&localNbWeight, &startIndex, 1, MPI_LONG, MPI_SUM, client->intraComm);
   
-  if (0 == globalNbWeight)
-  {
-    info << "There is no interpolation weights calculated between "
-         << "domain source: " << domainSrc_->getDomainOutputName()
-         << " and domain destination: " << domainDest_->getDomainOutputName()
-         << std::endl;
-    return;
-  }
-
   std::vector<StdSize> start(1, startIndex - localNbWeight);
   std::vector<StdSize> count(1, localNbWeight);
-  
-  WriteNetCdf netCdfWriter(filename, client->intraComm);  
+
+  WriteNetCdf netCdfWriter(filename, client->intraComm);
+
+  // netCdfWriter = CONetCDF4(filename, false, false, true, client->intraComm, false);
 
   // Define some dimensions
@@ -782,14 +745,8 @@
   netCdfWriter.addVariableWrite("weight", NC_DOUBLE, dims);
 
-  // End of definition
-  netCdfWriter.endDefinition();
-
   // // Write variables
-  if (0 != localNbWeight)
-  {
-    netCdfWriter.writeDataIndex(src_idx, "src_idx", false, 0, &start, &count);
-    netCdfWriter.writeDataIndex(dst_idx, "dst_idx", false, 0, &start, &count);
-    netCdfWriter.writeDataIndex(weights, "weight", false, 0, &start, &count);
-  }
+  netCdfWriter.writeDataIndex(src_idx, "src_idx", true, 0, &start, &count);
+  netCdfWriter.writeDataIndex(dst_idx, "dst_idx", true, 0, &start, &count);
+  netCdfWriter.writeDataIndex(weights, "weight", true, 0, &start, &count);
 
   netCdfWriter.closeFile();
Index: XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/domain_algorithm_interpolate.hpp	(revision 1037)
@@ -48,6 +48,4 @@
   CInterpolateDomain* interpDomain_;
   bool writeToFile_;
-  bool readFromFile_;
-  StdString fileToReadWrite_;
 
   // class WriteNetCdf;
@@ -59,5 +57,4 @@
     int addVariableWrite(const StdString& name, nc_type type,
                          const std::vector<StdString>& dim);
-    void endDefinition();
     void writeDataIndex(const CArray<int,1>& data, const StdString& name,
                         bool collective, StdSize record,
Index: XIOS/dev/branch_yushan/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/generic_algorithm_transformation.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/generic_algorithm_transformation.cpp	(revision 1037)
@@ -11,5 +11,4 @@
 #include "context_client.hpp"
 #include "client_client_dht_template.hpp"
-#include "utils.hpp"
 
 namespace xios {
@@ -32,11 +31,11 @@
                                             const double& defaultValue)
 {
-  int nbLocalIndex = localIndex.size();  
-  bool hasMissingValue = NumTraits<double>::isnan(defaultValue);  
+  int nbLocalIndex = localIndex.size();
+  bool hasMissingValue = (0.0 != defaultValue) ? true : false;
   if (hasMissingValue)
   {
     for (int idx = 0; idx < nbLocalIndex; ++idx)
     {
-      if (NumTraits<double>::isnan(*(dataInput + idx)))
+      if (defaultValue == *(dataInput + idx))
       {
         flagInitial[localIndex[idx].first] = false;
Index: XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp	(revision 1037)
@@ -531,5 +531,7 @@
 
   status.resize(requests.size());
+  //printf("(%d) src/transformation/grid_transformation 1st waitall\n", clientRank);
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
+  //printf("(%d) src/transformation/grid_transformation 1st waitall OK\n", clientRank);
 
   // Okie, now use the mask to identify which index source we need to send, then also signal the destination which masked index we will return
@@ -583,5 +585,7 @@
   }
   status.resize(requests.size());
+  //printf("(%d) src/transformation/grid_transformation 2nd waitall\n", clientRank);
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
+  //printf("(%d) src/transformation/grid_transformation 2nd waitall OK\n", clientRank);
 
   // Cool, now we can fill in local index of grid destination (counted for masked index)
Index: XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_extract_axis.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1037)
@@ -58,5 +58,5 @@
                                          const double& defaultValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, defaultValue);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
 }
 
Index: XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1037)
@@ -90,5 +90,5 @@
                                          const double& defaultValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, defaultValue);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
 }
 
Index: XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1037)
@@ -84,5 +84,5 @@
                                          const double& defaultValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, defaultValue);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
 }
 
Index: XIOS/dev/branch_yushan/src/utils.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/utils.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/utils.hpp	(revision 1037)
@@ -257,7 +257,4 @@
     return 1e-12;
   }
-  static inline bool isnan(const Scalar& v) {
-    return (v != v);
-  }
 };
 
Index: XIOS/dev/branch_yushan/src/xml_parser.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/xml_parser.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/xml_parser.cpp	(revision 1037)
@@ -70,8 +70,16 @@
                   CContext::setCurrent(attributes["id"]) ;
 
+                  bool hasctxt = CContext::has(attributes["id"]);
+
+                  if(hasctxt)
+                  {
+                     DEBUG("The context will not be processed because it exist an other context with the same id" );
+                     continue;
+                  }
 
                   if (isParseAll)
                   {
                     CContext* context = CContext::create(attributes["id"]);
+//                  if (!hasctxt)  group_context->addChild(context);
                     context->parse(node);
 
@@ -84,4 +92,5 @@
                     {
                       CContext* context = CContext::create(*it);
+  //                  if (!hasctxt)  group_context->addChild(context);
                       context->parse(node);
 
